/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.alarm.alarmgroup.controller;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import org.springblade.alarm.alarmgroup.entity.AlarmGroup;
import org.springblade.alarm.alarmgroup.service.IAlarmGroupService;
import org.springblade.alarm.alarmgroup.vo.AlarmGroupVO;
import org.springblade.community.residential.entity.Residential;
import org.springblade.community.residential.service.IResidentialService;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.homecare.alarmlist.entity.Alarm;
import org.springblade.system.orgposition.service.IOrgPositionService;
import org.springblade.utils.QueryWrapperUtil;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

/**
 * 告警处理组 控制器
 *
 * @author BladeX
 * @since 2020-11-29
 */
@RestController
@AllArgsConstructor
@RequestMapping("alarm/alarmgroup")
@Api(value = "告警处理组", tags = "告警处理组接口")
public class AlarmGroupController extends BladeController {

	private IAlarmGroupService alarmGroupService;
	private IResidentialService residentialService;
	private IOrgPositionService orgPositionService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入alarmGroup")
	public R<AlarmGroup> detail(AlarmGroup alarmGroup) {
		AlarmGroup detail = alarmGroupService.getOne(Condition.getQueryWrapper(alarmGroup));
		return R.data(detail);
	}

	/**
	 * 分页 告警处理组
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入alarmGroup")
	public R<IPage<AlarmGroup>> list(AlarmGroup alarmGroup, Query query, BladeUser bladeUser) {
		LambdaQueryWrapper<AlarmGroup> wrapper = new QueryWrapperUtil<AlarmGroup>().getBasicQueryWrapper(AlarmGroup::getOrgPosition, alarmGroup, bladeUser, orgPositionService);
		IPage<AlarmGroup> pages = alarmGroupService.page(Condition.getPage(query), wrapper);
		return R.data(pages);
	}

	/**
	 * 自定义分页 告警处理组
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入alarmGroup")
	public R<IPage<AlarmGroupVO>> page(AlarmGroupVO alarmGroup, Query query) {
		IPage<AlarmGroupVO> pages = alarmGroupService.selectAlarmGroupPage(Condition.getPage(query), alarmGroup);
		return R.data(pages);
	}

	/**
	 * 新增 告警处理组
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入alarmGroup")
	public R save(@Valid @RequestBody AlarmGroup alarmGroup) {

		return R.status(alarmGroupService.save(alarmGroup));
	}

	/**
	 * 修改 告警处理组
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入alarmGroup")
	public R update(@Valid @RequestBody AlarmGroup alarmGroup) {
		return R.status(alarmGroupService.updateById(alarmGroup));
	}

	/**
	 * 新增或修改 告警处理组
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入alarmGroup")
	public R submit(@Valid @RequestBody AlarmGroup alarmGroup) {
		Residential residential = residentialService.getById(alarmGroup.getResidentialId());
		Assert.notNull(residential, "选择的归属不存在！");
		alarmGroup.setResidentialName(residential.getName());
		if (alarmGroup.getId() == null){
			alarmGroupService.saveOrUpdate(alarmGroup);
		}
		alarmGroup.setOrgPosition(residential.getOrgPosition() +"/"+alarmGroup.getId());
		return R.status(alarmGroupService.saveOrUpdate(alarmGroup));
	}


	/**
	 * 删除 告警处理组
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
//		return R.status(alarmGroupService.deleteLogic(Func.toLongList(ids)));
		return R.status(alarmGroupService.removeGroup(Func.toLongList(ids)));
	}


	/**
	 * setOrgPosition
	 */
	@PostMapping("/setOrgPosition")
	public R setOrgPosition() {
		List<AlarmGroup> alarmGroups = alarmGroupService.getBaseMapper().selectList(new QueryWrapper<>(new AlarmGroup()));
		for (int i=0;i<alarmGroups.size();i++){
			AlarmGroup alarmGroup = alarmGroups.get(i);
			Residential residential = residentialService.getById(alarmGroup.getResidentialId());
			alarmGroup.setOrgPosition(residential.getOrgPosition()+"/"+alarmGroup.getId());
			alarmGroupService.updateById(alarmGroup);
		}

		return R.success("success");
	}
}
